;******************************************************************
;    program HPKimage
;
;    revised from imagespectro.pro
;         on Apr 8,2002 by TS
;
;    revised from imagesakanoi.pro
;      for plotting 'Auroral Spectrograph' data
;      developed at NIPR and now at LYR
;      on Apr. 20, 2000 by Takeshi Sakanoi
;
;    imagesakanoi.pro
;         revised from image20ps by Takeshi Sakanoi
;
;    image20ps
;    draws 20 airglow emission images and Japanese map
;    as a PostScript file. For Zao All-Sky Imager
;
;                              Mar . 21, 1997
;                               programed by K. Nakajima
;******************************************************************

PRO HPKimage_cal

; input parameters =====
;fna='Acquire (2)'
;fna='ch3_8x8_1000_240m'
;fna='ch1_8x8_2000_480m.img'
fna=''
;ibin=8
;ibin=2 or 4 or 8
deffna=1
;if deffna1 then, no automatic numbering is made.
;fdir = 'C:\Usr\tsakanoi\Index\Focus\2004_06_14\cam3_portrait\'
fdir = 'C:\Usr\tsakanoi\Index\Cal\data\'

;icol=1
;1 blue, 3 red,7 purple, 8 green
;=======================

;fname1=fdir+fna

fname1=FINDFILE(fdir+fna+'*.img')
fnum=n_elements(fname1)

fstartnum='001'
fs=fix(fstartnum)


fname=strarr(fnum)

;-------------

close,/all
iscale=1
;if iscale =1, then autoscale, if iscale=0 then manual setting as bellow
smin = 500l
smax = 2000l

xpx0=1024
ypx0=1024


pdate=0l
ptime=0l

;fdir = 'C:\Usr\tsakanoi\Index\MAC_test_hamaphoto_20020225\'



;--- ihiniti automatic - 1
ihiniti=1
;if ihiniti eq 0 then hiniti='Oct 24, 2000 neon lamp after re-inst.'

;psdir='C:\Usr\tsakanoi\Data_analysis\ps\'
psdir=fdir
;---plot image size factor(nominal:7.5, one image large plot:30)
;fac=7.5
fac=30.0

;--- pdate and ptime for data selection which is avairable when fac=30.0
;pdate=20000319
;ptime=210748

if fac lt 30 then begin
  fact=1.0
  factc=''
endif else begin
  fact=1.8
  factc='l'
endelse



irot = 2


;=====parameter end=====


;if fs eq 0 and min(sort(fname))/10.0 eq fix(min(sort(fname))/10.0) then begin
;   j=1
;    print, 'start from 1 !'
;endif else begin
;    j=0
;endelse

j=0





time=strarr(fnum)
date=strarr(fnum)
expo=strarr(fnum)

res=512

print, fname
;
print, '---data process start---'
print, 'file number = ',fnum
;
;----------  TIME AND IMAGE DATA FORMAT ------------------
;---image pixels
fn=''
time1=''
date1=''
time2=''
date2=''
expo1=''
pdate1=0l
ptime1=0l
ibin=intarr(fnum)

  imagetotal=LONARR(512,512,fnum)
image1=lonarr(512,512)

ave=fltarr(fnum,3)
rms=fltarr(fnum,3)
avech=strarr(fnum,3)
rmsch=strarr(fnum,3)
icol=intarr(fnum)

for i=0, fnum-1 do begin
  ich=fix(strmid(fname1(i),33,1))
  if ich eq 1 then begin
    icol(i)=1
  endif else if ich eq 2 then begin
    icol(i)=8
  endif else begin
    icol(i)=3
  endelse

  ibin1=fix(strmid(fname1(i),35,1))
  xpx=xpx0/ibin1
  ypx=ypx0/ibin1
  ibin(i)=ibin1
  ;res=xpx

  fn=fname1(i)
  print, i,'/',fnum-1,'     ',fn
  hp_img_HPK, fn, xpx, ypx, data, time1, date1, expo1
  image1=CONGRID(data, 512, 512, /INTERP)
;  print, data
  if fac eq 30.0 and ptime ne 0 and pdate ne 0 then begin
    time2=strmid(time1,0,2)+strmid(time1,3,2)+strmid(time1,6,2)
    date2=strmid(date1,0,4)+strmid(date1,5,2)+strmid(date1,8,2)
    pdate1=long(date2)
    ptime1=long(time2)
    print, long(date2),long(time2),pdate,ptime,pdate1-pdate,ptime1-ptime
    if ptime1 eq ptime and pdate1 eq pdate then begin
      print, 'found date and time ',date1,time1
      s0=0
      e0=0
      imagetotal(*,*,i)=image1
  ;    print, imagetotal
      time(i)=time1
      date(i)=date1
      expo(i)=expo1
      fnum=i
      goto, plot
    endif
  endif else begin
      imagetotal(*,*,i)=image1(*,*)
      time(i)=time1
      date(i)=date1
      expo(i)=expo1
  endelse



  image1=imagetotal(*,*,i)
;  ibin1=ibin1
  set_xs_ys,ibin1,512,xst,yst,xen,yen
  print, xst,xen
  for j=0,2 do begin
    result=moment(imagetotal(xst(j):xen(j),yst(j):yen(j),i))
    ave(i,j)=result(0)
    rms(i,j)=sqrt(result(1))
    print,'average:',ave(i,j)
    print,'rms:',rms(i,j)
    avech(i,j)=string(ave(i,j))
    rmsch(i,j)=string(rms(i,j))
  endfor
;  print, data

endfor

  if fac ne 30.0 then begin
    s0=0
    e0=FIX((fnum-1)/20)
  endif else begin
    s0=0
    e0=fnum-1
 ;   e0=FIX((fnum-1)/20)
  endelse




plot:



;------------------- PS PROT ------------------

SET_PLOT, 'PS'

es=e0

xpx2=512
ypx2=512
FOR s=s0,es DO BEGIN

if iscale eq 1 then begin
  smin=long(min(imagetotal(*,*,s))/5)*5l
  smax=long(max(imagetotal(*,*,s))/5)*5l
endif

if ihiniti eq 1 then hiniti=date(0)+' to '+date(fnum-1)
year=date(s)+strmid(time(s),0,2)+strmid(time(s),3,2)+factc


if ibin(s) eq 2 then begin
  cbin='2x2'
endif else if ibin(s) eq 4 then begin
  cbin='4x4'
endif else if ibin(s) eq 8 then begin
  cbin='8x8'
endif

fo=STRING(s+1)
fo=STRTRIM(fo,1)

;st=0+20*s
;et=st+20-1

;if et gt fnum-1 then et=fnum-2

psnam= strmid(fname1(s),0,strpos(fname1(s),'img'))+'ps'
fna=strmid(fname1(s),strpos(fname1(s),'ch'),strpos(fname1(s),'img'))

DEVICE, BITS_PER_PIXEL=8, /COLOR, $
 FILENAME=psnam, /PORTRAIT, $
 XSIZE=21.0, YSIZE=29.7, XOFFSET=0.0, YOFFSET=0.0
print, psnam
icol1=icol(s)
LOADCT, icol1


!P.FONT=0
XYOUTS, 2100, 28000, '!8MAC Cal Data: '+fna, $
 CHARSIZE=2.0,  CHARTHICK=1.2,  /DEVICE
XYOUTS,  9800, 26800, cbin+'  binning', $
 CHARSIZE=0.8*fact,  CHARTHICK=1.0,  /DEVICE
datec=''
if fac eq 30.0 then begin
  datec='Date: '+ date(s)+''
endif else begin
  datec= 'Date: '+ date(s)+''
endelse
XYOUTS,  4000, 26800, datec,CHARSIZE=0.8*fact,  CHARTHICK=1.0,   /DEVICE

print,datec

;XYOUTS, 2800, 26100, 'North', $
; CHARSIZE=1.0,  CHARTHICK=1,   /DEVICE
;XYOUTS, 900, 23300, 'East', $
; CHARSIZE=1.0,  CHARTHICK=1,  ORIENTATION=90, /DEVICE
;XYOUTS, 900, 26500-((xpx)*fac)/2.0-500, 'East', $
; CHARSIZE=1.0,  CHARTHICK=1,  ORIENTATION=90, /DEVICE

colorbar=BYTSCL(FINDGEN(100))#REPLICATE(1,16)
xsi=4500*0.9
ysi=400.0
xsc=15000.0
ysc=26500.0
TV, colorbar, xsc, ysc, XSIZE=xsi, YSIZE=ysi,/DEVICE
plots, [xsc,xsc],[ysc,ysc+ysi+60],/device
plots, [xsc+xsi,xsc+xsi],[ysc,ysc+ysi+60],/device

  XYOUTS, xsc+1000.0, ysc+ysi+100.0, 'intensity (cts)', $
   CHARSIZE=0.8,  CHARTHICK=1,   /DEVICE
  xyouts, xsc-700.0, ysc+ysi+100.0, smin, charsize=0.8, charthick=1, /device
  xyouts, xsc-700.0+xsi, ysc+ysi+100.0, long(smax), charsize=0.8, charthick=1, /device


;------------------ DRAW IMAGE DATA  --------------
;

xs=2500.0+1000*(fact-1.0)
xd=4300.0
ys=24500.0
cm=''
yd=800.0
pix=0.0
xpi=0.0
ypi=0.0
xpx=xpx2
ypx=ypx2
;---plotting images
n=s
;  print,n
k=0
l=0
   sx=xs+xd*k
   sy=ys-((xpx)*fac+yd)*(l+1)
   if fac eq 30.0 then begin
     XYOUTS, xs+xd*k+20*fac, ys+fac*50, time(n)+'(JST) / Exp='+expo(n),CHARSIZE=0.8*fact, /DEVICE
   endif else begin
     XYOUTS, xs+xd*k, (ys-400.0)-((xpx)*fac+yd+500*(fact-1))*(l+1), time(n)+'(JST) / Exp='+expo(n)+'(s)',CHARSIZE=0.8*fact, /DEVICE
   endelse

   ;TV, ROTATE(bytscl(imagetotal(*,*,n),min=smin,max=smax),irot), sx, sy, $
   ;   XSIZE=(xpx)*fac, YSIZE=(ypx)*fac, /DEVICE
   TV, ROTATE(bytscl(imagetotal(*,*,n),min=smin,max=smax),irot), sx, sy, $
      XSIZE=(xpx)*fac, YSIZE=(ypx)*fac, /DEVICE

     xyouts, 5000,6500,'Average: ', charsize=0.8*fact, charthick=1.0,  /DEVICE
     xyouts, 7000,6500, ave(s,0),charsize=0.8*fact, charthick=1.0,  /DEVICE
     xyouts, 10500,6500, ave(s,1),charsize=0.8*fact, charthick=1.0,  /DEVICE
     xyouts, 14000,6500, ave(s,2),charsize=0.8*fact, charthick=1.0,  /DEVICE
     xyouts, 5000,5500,'SD(rms): ',charsize=0.8*fact, charthick=1.0,  /DEVICE
     xyouts, 7000,5500, rms(s,0),charsize=0.8*fact, charthick=1.0,  /DEVICE
     xyouts, 10500,5500, rms(s,1),charsize=0.8*fact, charthick=1.0,  /DEVICE
     xyouts, 14000,5500, rms(s,2),charsize=0.8*fact, charthick=1.0,  /DEVICE

  ; TVSCL, ROTATE((imagetotal(*,*,n)-smin)/(smax-smin),irot), sx, sy, $
  ;    XSIZE=(xpx)*fac, YSIZE=(ypx)*fac, /DEVICE
   if fac ne 30.0 then begin
   endif else begin
     if l eq 0 then begin
       for m=0, 512, 50 do begin
         pix=float(m)
         xpi=sx+xpx*fac*pix/xpx
         plots, [xpi,xpi], [sy+ypx*fac,sy+ypx*fac+100*fact],/device
         cm=strmid(string(fix(m)),5,3)
         xyouts, xpi-220*fact, sy+ypx*fac+150*fact, cm, charsize=0.8*fact,/device
         if k eq 0 then xyouts, xs+800*fact+5000*(fact-1), sy+ypx*fac+600*fact,'  CCD pixels', charsize=0.8*fact,/device
       endfor
     endif
   endelse

DEVICE, /CLOSE

ENDFOR

NODATA:

;------------------- END ---------------------------


print, 'Normal End! '
END











