      pro RHAND_small, X,Y,Z,R1,R2,R3,IOPT,PARMOD,exname,fac
;C
;C  COMPUTES RIGHT HAND EXPRESSIONS IN THE GEOMAGNETIC FIELD LINE EQUATION
;C      (a subsidiary subroutine for the subr. STEP)
;C
;C     LAST MODIFICATION:  JAN 5, 2001 (NO ESSENTIAL CHANGES, BUT
;C                            SOME REDUNDANT STATEMENTS TAKEN OUT)
;C
;C     WRITTEN BY:  N. A. TSYGANENKO
;C
;      DIMENSION PARMOD(10)
;      EXTERNAL EXNAME
;C
;      COMMON /GEOPACK/ A(15),PSI,AA(10),DS3,K,IY,BB(8)
      COMMON GEOPACK, ST0,CT0,SL0,CL0,CTCL,STCL,CTSL,STSL,SFI,CFI,SPS,$
       CPS,SHI,CHI,HI,PSI,XMUT,A11,A21,A31,A12,A22,A32,A13,A23,A33,DS3,$
       K,IY,CGST,SGST

      if exname eq 'IGRF' then begin
 ;       GEOGSM, XG,YG,ZG,X,Y,Z,-1
 ;       SPHCAR, R,T,F,XG,YG,ZG,-1
 ;       igrf_geopack,iy,k,r,t,f,br,bt,bf
 ;       BSPCAR,T,F,BR,BT,BF,FX,FY,FZ
 ;       GEOGSM,FX,FY,FZ,HX,HY,HZ,1
  ;      stop
       BX=0.0
       BY=0.0
       BZ=0.0
      endif

      IF (K EQ 0) then GOTO, lavel1
      GEOGSM, XG,YG,ZG,X,Y,Z,-1
      SPHCAR, R,T,F,XG,YG,ZG,-1
;      print, r,t,f,x,y,z,xg,yg,zg
;      stop
      IGRF_geopack,IY,K,R,T,F,BR,BT,BF
 ;     print, XG,YG,ZG,'BR,BT,BF',BR,BT,BF
      BSPCAR,T,F,BR,BT,BF,FX,FY,FZ
      GEOGSM,FX,FY,FZ,HX,HY,HZ,1
;      stop
      GOTO, lavel2
  lavel1:
      DIP,PSI,X,Y,Z,HX,HY,HZ
  lavel2:
      BX=BX+HX
      BY=BY+HY
      BZ=BZ+HZ
      B=DS3/SQRT(BX^2+BY^2+BZ^2)
      R1=BX*B/fac
      R2=BY*B/fac
      R3=BZ*B/fac
      RETURN
      END
